#ifndef SBI_H
#define SBI_H

#include "cpu/rv32cpu.h"

/* SBI Base extension */
#define SBI_EXTENSION_BASE 0x10
#define SBI_FUNCTION_GET_SPEC_VERSION 0x0
#define SBI_FUNCTION_GET_IMPL_ID 0x1
#define SBI_FUNCTION_GET_IMPL_VERSION 0x2
#define SBI_FUNCTION_PROBE_EXTENSION 0x3
#define SBI_FUNCTION_GET_MVENDOR_ID 0x4
#define SBI_FUNCTION_GET_MARCH_ID 0x5
#define SBI_FUNCTION_GET_MIMPL_ID 0x6

/* SBI Timer extension */
#define SBI_EXTENSION_TIMER 0x54494d45
#define SBI_FUNCTION_SET_TIMER 0x0

/* SBI legacy */
#define SBI_EXTENSION_SET_TIMER 0x0
#define SBI_EXTENSION_LEGACY_CONSOLE_PUTCHAR 0x1
#define SBI_EXTENSION_LEGACY_SHUTDOWN 0x8

void sbi_call(rv32_cpu_t* cpu, uint32_t extension_id, uint32_t func_id);

#endif
